unit ML05R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU01_p, MLU37_p, MLU38_p, MLU39_p, MLU36_p, MLU32_p, MLU41_p,
MLU18_p, MLU07_p, MLU42_p;

procedure ML05R(var ST :Array of Real; var U :Array of Real;
                M :Integer; var X :Array of Real;
                var XK :Array of Real; N :Integer;
                var NX :Array of Integer; var P :Integer;
                EPS :Real; var ALFA :Array of Real;
                var NALFA :Array of Integer; var KV :Integer;
                F :Proc_F3AI; var NB :Array of Integer);

implementation

procedure ML05R(var ST :Array of Real; var U :Array of Real;
                M :Integer; var X :Array of Real;
                var XK :Array of Real; N :Integer;
                var NX :Array of Integer; var P :Integer;
                EPS :Real; var ALFA :Array of Real;
                var NALFA :Array of Integer; var KV :Integer;
                F :Proc_F3AI; var NB :Array of Integer);
var
KW,I,K,NI,NE,M1,I1,L,NA :Integer;
MIN,TETA :Real;
NW :Array [0..49] of Integer;
const
O10T10 :Real = 10.0E10;
label
_1,_4,_5,_6,_7,_8,_9,_10,_11,_12,_100,_200,_300,_13;
begin
KW := 0;
MLU01(U,M);
for I:=1 to M do
 begin
  K := N+I;
  NB[I-1] := K;
_1:
  NX[I-1] := K;
 end;
NI := 0;
NE := 1;
_4:
MLU37(MIN,K,ST,M,U,F,NB,NW,KW,
N,ALFA,KV,NALFA);
goto _7;
_5:
MLU38(MIN,K,ST,M,U,F,NB,
N,ALFA,KV,NALFA);
goto _7;
_6:
MLU39(MIN,K,ST,M,U,F,NB,
N,ALFA,KV,NALFA,EPS);
_7:
if ( MIN < (-EPS) )
 then goto _10;
case NE of
 1: goto _8;
 2: goto _100;
 3: goto _100;
end;
_8:
NE := 2;
M1 := M-2;
for I:=1 to M1 do
 begin
  I1 := NB[I-1];
  if ( I1 > N )
   then NE := 3;
_9:
 end;
if ( NE = 3 ) and ( X[M-1] < (-EPS) )
 then goto _200;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_10:
MLU36(K,XK,M,ST,U,F);
MLU32(X,M,XK,K,L,TETA,NX,EPS,
ALFA,KV,NA,NALFA);
if ( TETA = O10T10 )
 then goto _300;
MLU41(TETA,L,K,XK,M,ALFA,KV,
NALFA,NA,X,NX,NW,KW);
_11:
MLU18(X,XK,M,K,L,TETA,ALFA,KV,NA);
if ( L = 0 )
 then goto _12;
MLU07(U,M,XK,L);
MLU42(NX,M,NB,K,L);
_12:
NI := NI+1;
case NE of
 1: goto _4;
 2: goto _5;
 3: goto _6;
end;
_100:
P := 1;
X[M-2] := -X[M-2];
goto _13;
_200:
P := 2;
goto _13;
_300:
P := 3;
_13:
end;

end.
