Unit MLU18_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure MLU18(var X :Array of Real; var XK :Array of Real;
                M :Integer; K :Integer; L :Integer; TETA :Real;
                var ALFA :Array of Real; KV :Integer; NA :Integer);

implementation

procedure MLU18(var X :Array of Real; var XK :Array of Real;
                M :Integer; K :Integer; L :Integer; TETA :Real;
                var ALFA :Array of Real; KV :Integer; NA :Integer);
var
I,J :Integer;
label
_4,_3,_2,_1;
begin
{      BAPAHT S/R MLU06  CYA OPAH- }
{     EHHX CBEPXY EPEMEHHX. }
for I:=1 to M do
 begin
  if ( I <> L )
   then goto _2;
  if ( NA = 0 )
   then goto _4;
  if ( TETA < 0.0 )
   then goto _3;
_4:
  X[L-1] := TETA;
  goto _1;
_3:
  X[L-1] := ALFA[NA-1]+TETA;
  goto _1;
_2:
  X[I-1] := X[I-1]-TETA*XK[I-1];
  if ( I >= M-1 )
   then goto _1;
  if ( X[I-1] < 0.0 )
   then X[I-1] := 0.0;
_1:
 end;
end;

end.
