Unit MLU39_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, MLU25_p;

procedure MLU39(var MIN :Real; var K :Integer; var ST :Array of Real;
                M :Integer; var U :Array of Real; F :Proc_F3AI;
                var NB :Array of Integer; N :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; EPS :Real);

implementation

procedure MLU39(var MIN :Real; var K :Integer; var ST :Array of Real;
                M :Integer; var U :Array of Real; F :Proc_F3AI;
                var NB :Array of Integer; N :Integer;
                var ALFA :Array of Real; KV :Integer;
                var NALFA :Array of Integer; EPS :Real);
var
K2,K3,K11,I,J :Integer;
DEL,DEL1 :Real;
const
O01E6 :Real = 0.1E-6;
O16000 :Integer = 16000;
label
_4,_2,_3,_5,_6,_1;
begin
{      OCK HAOEE EPCEKTBHOO }
{      CTOA HA TPETEM TAE }
K3 := 0;
K11 := 1;
MIN := 0.0;
I := 1;
for J:=1 to N do
 begin
_4:
  if ( NB[I-1]-J ) < 0
   then goto _2
   else if ( NB[I-1]-J ) > 0
         then goto _3
         else goto _1;
_2:
  if ( I = M )
   then goto _3;
  I := I+1;
  goto _4;
_3:
  if ( K11 > KV )
   then goto _5;
  K2 := NALFA[K11-1];
  K3 := K2;
  if ( K2 > 16000 )
   then K3 := K2-16000;
  if ( K3 = J ) and ( ALFA[K11-1] < O01E6 )

   then goto _1;
  if ( J <= K3 )
   then goto _5;
  K11 := K11+1;
  goto _3;
_5:
  MLU25(DEL1,DEL,J,ST,M,F,U);
  if ( J <> K3 )
   then goto _6;
  if ( K2 > 16000 )
   then DEL := -DEL;
_6:
  if ( DEL >= MIN )
   then goto _1;
  if ( Abs(DEL1) >= EPS )
   then goto _1;
  MIN := DEL;
  K := J;
_1:
 end;
end;

end.
